from rocolib.api.components import Component
import rocolib.utils.numsym as np

c = Component()

#Body of sides
c.addSubcomponent("side0", "Trapezoid")
for i in range(3):
    c.addSubcomponent("r%d" %i, "Rectangle")

c.addParameter("length", 96, paramType="length")
c.addParameter("width", 12.5, paramType="length")
c.addParameter("topwidth", 14, paramType="length")
c.addParameter("facewidth", float(c.getSubCParameter("width") * np.sqrt(2.)), paramType="length")

c.addConstraint(("side0", "width"), "length")
c.addConstraint(("side0", "depth"), "width")

c.addConstraint(("r0", "w"), "length")
c.addConstraint(("r0", "l"), "topwidth")

for i in range(1,3):
    c.addConstraint(("r%d" %i, "w"), "topwidth")
    c.addConstraint(("r%d" %i, "l"), "facewidth")

c.addConnection(("r0", "l"), ("side0", "topedge"), angle=90)
c.addConnection(("side0", "redge"), ("r1", "t"), angle=90)
c.addConnection(("side0", "ledge"), ("r2", "t"), angle=90)

#Adding splitedge to attach to the body of the tank
c.addSubcomponent("split0", "SplitEdge")
c.addConstraint(("split0", "toplength"), "length", "(x,)")
c.addConstraint(("split0", "botlength"), "length", "((x - 55)/2., x - (x - 55), (x - 55)/2.)")

c.inheritInterface(("sideedge"), ("r0", "r"))


c.toLibrary("TankSide")